package krusty;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import spark.Request;
import spark.Response;

public class Database {
	/**
	 * Modify it to fit your environment and then use this string when connecting to your database!
	 */
	private static final String jdbcString = "jdbc:mysql://pusp.cs.lth.se:3306/iv4171bo";

	// For use with MySQL or PostgreSQL
	private static final String jdbcUsername = "iv4171bo";
	private static final String jdbcPassword = "i2qtnm8z";

	private Connection conn;

	public void connect() {
		// Connect to database here
		try {
        	// Connection strings for included DBMS clients:
        	// [MySQL]       jdbc:mysql://[host]/[database]
        	// [PostgreSQL]  jdbc:postgresql://[host]/[database]
        	// [SQLite]      jdbc:sqlite://[filepath]
        	
        	// Use "jdbc:mysql://puccini.cs.lth.se/" + userName if you using our shared server
        	// If outside, this statement will hang until timeout.
            conn = DriverManager.getConnection 
                (jdbcString, jdbcUsername, jdbcPassword);
        }
        catch (SQLException e) {
            System.err.println(e);
            e.printStackTrace();
        }
	}

	// TODO: Implement and change output in all methods below!

	public String getCustomers(Request req, Response res) {
		String query = "SELECT name, address FROM Customer";
		String title = "customers"; //ändra inte det är till för testet, söker efter just "customers" små bokstäver

		return getJson(query, title);
		
	}

	public String getRawMaterials(Request req, Response res) {
		String query = "SELECT ingredient_name as name, stock as amount, unit FROM Ingredient";
		String title = "raw-materials";
		
		return getJson(query, title);
	}

	public String getCookies(Request req, Response res) {
		String query = "Select name from Cookie";
		String title = "cookies";
		
		
		return getJson(query, title);
	}

	public String getRecipes(Request req, Response res) {
		String query = "Select r.cookie_name, i.ingredient_name, r.amount, i.unit From Ingredient i, Recipe r WHERE r.ingredient_name = i.ingredient_name;";
		String title = "recipes";
		
		return getJson(query, title);
	}

	public String getPallets(Request req, Response res) {
		String query = "Select cookie_name as cookie, blocked From Pallet;";
		String title = "pallets";
		return getJson(query, title);
	}

	public String reset(Request req, Response res) {
		try {
			// Reset Customers
			String resetCustomersQuery = "TRUNCATE TABLE Customer; INSERT INTO Customer(name, address) " +
					"SELECT name, address FROM (VALUES " +
					"('Finkakor AB', 'Helsingborg'), " +
					"('Småbröd AB', 'Malmö'), " +
					"('Kaffebröd AB', 'Landskrona'), " +
					"('Bjudkakor AB', 'Ystad'), " +
					"('Kalaskakor AB', 'Trelleborg'), " +
					"('Partykakor AB', 'Kristianstad'), " +
					"('Gästkakor AB', 'Hässleholm'), " +
					"('Skånekakor AB', 'Perstorp')) AS temp(name, address)";
			conn.createStatement().executeUpdate(resetCustomersQuery);
	
			// Reset Cookies
			String resetCookiesQuery = "TRUNCATE TABLE Cookie; INSERT INTO Cookie(name) " +
					"SELECT name FROM (VALUES " +
					"('Nut ring'), " +
					"('Nut cookie'), " +
					"('Amneris'), " +
					"('Tango'), " +
					"('Almond delight'), " +
					"('Berliner')) AS temp(name)";
			conn.createStatement().executeUpdate(resetCookiesQuery);
	
			// Reset Ingredients
			String resetIngredientsQuery = "TRUNCATE TABLE Ingredient; INSERT INTO Ingredient(ingredient_name, stock, unit) " +
					"SELECT ingredient_name, stock, unit FROM (VALUES " +
					"('Bread crumbs', 500000, 'g'), " +
					"('Butter', 500000, 'g'), " +
					"('Chocolate', 500000, 'g'), " +
					"('Chopped almonds', 500000, 'g'), " +
					"('Cinnamon', 500000, 'g'), " +
					"('Egg whites', 500000, 'ml'), " +
					"('Eggs', 500000, 'g'), " +
					"('Fine-ground nuts', 500000, 'g'), " +
					"('Flour', 500000, 'g'), " +
					"('Ground, roasted nuts', 500000, 'g'), " +
					"('Icing sugar', 500000, 'g'), " +
					"('Marzipan', 500000, 'g'), " +
					"('Potato starch', 500000, 'g'), " +
					"('Roasted, chopped nuts', 500000, 'g'), " +
					"('Sodium bicarbonate', 500000, 'g'), " +
					"('Sugar', 500000, 'g'), " +
					"('Vanilla sugar', 500000, 'g'), " +
					"('Vanilla', 500000, 'g'), " +
					"('Wheat flour', 500000, 'g')) AS temp(ingredient_name, stock, unit)";
			conn.createStatement().executeUpdate(resetIngredientsQuery);
	
			// Reset Recipes
			String resetRecipesQuery = "TRUNCATE TABLE Recipe; INSERT INTO Recipe(ingredient_name, cookie_name, amount) " +
					"SELECT ingredient_name, cookie_name, amount FROM (VALUES " +
					"('Butter', 'Nut ring', 450),('Flour', 'Nut ring', 450),('Icing sugar', 'Nut ring', 190),('Roasted, chopped nuts', 'Nut ring', 225), " +
					"('Bread crumbs', 'Nut cookie', 125),('Chocolate', 'Nut cookie', 50),('Egg whites', 'Nut cookie', 350),('Fine-ground nuts', 'Nut cookie', 750),('Ground, roasted nuts', 'Nut cookie', 625),('Sugar', 'Nut cookie', 375), " +
					"('Butter', 'Amneris', 250),('Eggs', 'Amneris', 250),('Marzipan', 'Amneris', 750),('Potato starch', 'Amneris', 25),('Wheat flour', 'Amneris', 25), " +
					"('Butter', 'Tango', 200),('Flour', 'Tango', 300),('Sodium bicarbonate', 'Tango', 4),('Sugar', 'Tango', 250),('Vanilla', 'Tango', 2), " +
					"('Butter', 'Almond delight', 400),('Chopped almonds', 'Almond delight', 279),('Cinnamon', 'Almond delight', 10),('Flour', 'Almond delight', 400),('Sugar', 'Almond delight', 270), " +
					"('Butter', 'Berliner', 250),('Chocolate', 'Berliner', 50),('Eggs', 'Berliner', 50),('Flour', 'Berliner', 350),('Icing sugar', 'Berliner', 100),('Vanilla sugar', 'Berliner', 5)) AS temp(ingredient_name, cookie_name, amount)";
			conn.createStatement().executeUpdate(resetRecipesQuery);
	
			// Clear Pallets
			String clearPalletsQuery = "TRUNCATE TABLE Pallet";
			conn.createStatement().executeUpdate(clearPalletsQuery);
	
			// Return JSON response
			return "{\"status\": \"ok\"}";
		} catch (SQLException e) {
			e.printStackTrace();
			return "{\"status\": \"error\"}";
		}
	}
	

	public String createPallet(Request req, Response res) {
		if (req.queryParams("cookie") != null) {
			String cookie = req.queryParams("cookie");
			return createPallet(cookie);
		  } else {
			return "";
		  }
		}

		protected String createPallet(String cookie) {
			String query = "Insert into Pallet (manufacture_date, cookie_name) VALUES (NOW(), ?);";
			try (PreparedStatement stmt = conn.prepareStatement(query)) {
				stmt.setString(1, cookie);
				stmt.executeUpdate();
				removeMaterials(cookie);
			} catch (SQLException e) {
				return "bob";
			}
			return "";
		  }
		



	private String getJson(String query, String title) { //privat hjälpmetod så man slipper kalla på jsonizer varje gång
		try (PreparedStatement stmt = conn.prepareStatement(query)) {
			ResultSet rs = stmt.executeQuery();
			return Jsonizer.toJson(rs, title);
		} catch (SQLException e) {
			return "";
		}
	}
	public void removeMaterials(String cookie) { //privat hjälpmetod för att minska antalet material efter man gör en pallet
		String query = "Select ingredient_name, amount from Recipe where cookie_name = ?;";
		String query2 = "UPDATE Ingredient SET stock = stock - ? WHERE ingredient_name = ?;";

		try (PreparedStatement stmt = conn.prepareStatement(query)) {
			stmt.setString(1, cookie);
			ResultSet rs = stmt.executeQuery();
			while(rs.next()) { //loopar igenom och uppdaterar all material
				try (PreparedStatement stmt2 = conn.prepareStatement(query2)) {
					stmt2.setInt(1, rs.getInt("amount") * 54); //54 för (10*15*36)/100 = 10 kakor per låda, 15 lådor per box 36 boxar per pallet, materialet är för 100 kakor därför man delar allt med 100
					stmt2.setString(2, rs.getString("ingredient_name"));
					stmt2.executeUpdate();
				} catch (SQLException e) {
				}
			}
		} catch (SQLException e){
			//return false;
		}
		//return true;
	}
}
